Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/execution/InstallPackageServiceFrame.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/execution/InstallPackageServiceFrame.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/execution/InstallPackageServiceFrame.java	(revision 43126)
@@ -35,8 +35,8 @@
 import org.gvsig.installer.lib.api.execution.InstallPackageServiceException;
 import org.gvsig.installer.main.utils.FrameWizardListener;
 import org.gvsig.installer.swing.api.SwingInstallerLocator;
-import org.gvsig.installer.swing.api.execution.AbstractInstallPackageWizard;
 import org.gvsig.installer.swing.api.execution.InstallPackageWizardException;
+import org.gvsig.installer.swing.api.execution.InstallWizardPanel;
 import org.gvsig.tools.locator.LocatorException;
 
 /**
@@ -45,24 +45,24 @@
 public class InstallPackageServiceFrame extends JFrame {
 
 	private static final long serialVersionUID = -5107758157530922356L;
-	private AbstractInstallPackageWizard installerExecutionWizard;
+        private final InstallWizardPanel installerExecutionWizard;
 
 	public InstallPackageServiceFrame(File applicationFolder, File installFolder)
 			throws LocatorException, InstallPackageWizardException {
 		super();
 		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
-		installerExecutionWizard = SwingInstallerLocator
+		this.installerExecutionWizard = SwingInstallerLocator
 				.getSwingInstallerManager().createInstallPackageWizard(
 						applicationFolder, installFolder);
 		installerExecutionWizard
 				.setWizardActionListener(new FrameWizardListener(this));
-		this.add(installerExecutionWizard);
+		this.add(installerExecutionWizard.asJComponent());
 		pack();
 	}
 
-	public void installFromDefaultDirectory()
-			throws InstallPackageServiceException {
-		installerExecutionWizard.installFromDefaultDirectory();
-	}
+//	public void installFromDefaultDirectory()
+//			throws InstallPackageServiceException {
+//		installerExecutionWizard.installFromDefaultDirectory();
+//	}
 
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/execution/InstallPackageWizardFromDefaultDirectoryLauncher.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/execution/InstallPackageWizardFromDefaultDirectoryLauncher.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/execution/InstallPackageWizardFromDefaultDirectoryLauncher.java	(revision 43126)
@@ -55,7 +55,7 @@
 
 		InstallPackageServiceFrame frame = new InstallPackageServiceFrame(
 				getApplicationFolder(), getInstallFolder());
-		frame.installFromDefaultDirectory();
+//		frame.installFromDefaultDirectory();
 		frame.setVisible(true);
 	}
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/creation/MakePluginPackageFrame.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/creation/MakePluginPackageFrame.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.main/src/main/java/org/gvsig/installer/main/creation/MakePluginPackageFrame.java	(revision 43126)
@@ -55,7 +55,7 @@
 						applicationFolder, installFolder);
 		installerCreationWizard
 				.setWizardActionListener(new FrameWizardListener(this));
-		this.add(installerCreationWizard);
+		this.add(installerCreationWizard.asJComponent());
 		pack();
 	}
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.api/src/main/java/org/gvsig/installer/lib/api/execution/InstallPackageService.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.api/src/main/java/org/gvsig/installer/lib/api/execution/InstallPackageService.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.api/src/main/java/org/gvsig/installer/lib/api/execution/InstallPackageService.java	(revision 43126)
@@ -31,6 +31,7 @@
 import java.io.File;
 import java.net.URL;
 import java.util.List;
+import java.util.Properties;
 
 import org.gvsig.installer.lib.api.InstallerManager;
 import org.gvsig.installer.lib.api.PackageInfo;
@@ -62,12 +63,12 @@
 	 * bundle is a compressed zip file with a structure defined in the
 	 * {@link InstallerManager} class.
 	 * 
-	 * @param bundleURI
-	 *            the URI of a bundle.
+         * @param bundleFile
+         * @param taskStatus
 	 * @throws InstallPackageServiceException
 	 *             it is thrown if there is an exception reading the URI.
 	 */
-	public void addBundle(File bundleFile)
+	public void addBundle(File bundleFile, SimpleTaskStatus taskStatus)
 			throws InstallPackageServiceException;
 
 	/**
@@ -77,11 +78,12 @@
 	 * 
 	 * @param bundleURL
 	 *            the {@link URL} of a bundle.
+         * @param taskStatus
 	 * @throws InstallPackageServiceException
 	 *             it is thrown if there is an exception reading the {@link URL}
 	 *             .
 	 */
-	public void addBundle(URL bundleURL) throws InstallPackageServiceException;
+	public void addBundle(URL bundleURL, SimpleTaskStatus taskStatus) throws InstallPackageServiceException;
 
 	/**
 	 * In reads a directory and reads all the bundles. This method retrieve all
@@ -90,10 +92,11 @@
 	 * 
 	 * @param bundlesDirectory
 	 *            a directory that contains bundles.
+         * @param taskStatus
 	 * @throws InstallPackageServiceException
 	 *             If there is any problem reading the directory of bundles.
 	 */
-	public void addBundlesFromDirectory(File bundlesDirectory)
+	public void addBundlesFromDirectory(File bundlesDirectory, SimpleTaskStatus taskStatus)
 			throws InstallPackageServiceException;
 
 	/**
@@ -172,14 +175,17 @@
 			SimpleTaskStatus taskStatus) throws InstallPackageServiceException;
 
 	/**
-     * 
-     */
-	// public void resetPackages();
-
-	/**
 	 * @return
 	 */
 	public List<String> getDefaultSelectedPackagesIDs();
+        
+        /**
+         * Get the proprties associates to this bundle.
+         * Return an empty Propertis if the bundle dont have a properties.
+         * 
+         * @return 
+         */
+        public Properties getProperties();
 
 	/**
 	 * Gets the list of all the categories of *all* the packages.
@@ -194,4 +200,8 @@
 	 * @return a list with the types of packages.
 	 */
 	public List<String> getTypes();
+        
+        public boolean needInstallPackageProviders();
+        
+        public void installPackageProviders(SimpleTaskStatus taskStatus);
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.spi/src/main/java/org/gvsig/installer/lib/spi/InstallPackageProviderServices.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.spi/src/main/java/org/gvsig/installer/lib/spi/InstallPackageProviderServices.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.spi/src/main/java/org/gvsig/installer/lib/spi/InstallPackageProviderServices.java	(revision 43126)
@@ -33,11 +33,13 @@
 import java.io.OutputStream;
 import java.util.List;
 import java.util.Map;
+import java.util.Properties;
 
 import org.gvsig.installer.lib.api.PackageInfo;
 import org.gvsig.installer.lib.api.creation.MakePluginPackageServiceException;
 import org.gvsig.installer.lib.api.execution.InstallPackageServiceException;
 import org.gvsig.tools.service.spi.ProviderServices;
+import org.gvsig.tools.task.SimpleTaskStatus;
 
 /**
  * Services that can be used by the providers to create or exceute the bundle.
@@ -135,7 +137,7 @@
 	 */
 	public void readPackageSetInfo(InputStream is,
 			List<PackageInfo> packageInfos,
-			Map<PackageInfo, String> zipEntriesMap)
+			Map<PackageInfo, String> zipEntriesMap, SimpleTaskStatus taskStatus)
 			throws InstallPackageServiceException;
 
 	/**
@@ -153,7 +155,7 @@
 	 *             if there is a problem reading the bundle.
 	 */
 	public void readPackageInfo(InputStream is, List<PackageInfo> packageInfos,
-			Map<PackageInfo, String> zipEntriesMap, String name)
+			Map<PackageInfo, String> zipEntriesMap, String name, SimpleTaskStatus taskStatus)
 			throws InstallPackageServiceException;
 
 	/**
@@ -212,4 +214,5 @@
 
 	public List<String> getDefaultSelectedPackagesIDs();
 
+        public Properties getProperties();
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/utils/Decompress.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/utils/Decompress.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/utils/Decompress.java	(revision 43126)
@@ -37,6 +37,7 @@
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Map;
+import java.util.Properties;
 import java.util.zip.ZipEntry;
 import java.util.zip.ZipException;
 import java.util.zip.ZipInputStream;
@@ -45,16 +46,15 @@
 import org.slf4j.LoggerFactory;
 import org.apache.commons.io.FileUtils;
 import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.io.IOUtils;
 import org.gvsig.installer.lib.api.PackageInfo;
 import org.gvsig.installer.lib.api.execution.InstallPackageServiceException;
 import org.gvsig.installer.lib.impl.DefaultPackageInfo;
 import org.gvsig.installer.lib.impl.info.InstallerInfoFileReader;
 import org.gvsig.installer.lib.spi.InstallerInfoFileException;
 import org.gvsig.installer.lib.spi.InstallerProviderLocator;
-import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.service.ServiceException;
 import org.gvsig.tools.task.SimpleTaskStatus;
-import org.gvsig.tools.task.TaskStatusManager;
 
 /**
  * @author <a href="mailto:jpiera@gvsig.org">Jorge Piera Llodr&aacute;</a>
@@ -77,11 +77,18 @@
 	private List<PackageInfo> selectedInstallerInfos = null;
 	private Map<PackageInfo, String> zipEntriesMap = null;
 	private List<String> defaultSelectedPackets = null;
-
+        private Properties properties;
+        private SimpleTaskStatus taskStatus = null;
+        
 	public Decompress() {
-
+            this.properties = new Properties();
 	}
-
+        
+	public Decompress(SimpleTaskStatus taskStatus) {
+            this();
+            this.taskStatus = taskStatus;
+        }
+        
 	public void decompressPlugins(InputStream is, File outputDirectory)
 			throws InstallPackageServiceException {
 		option = OPTION_DECOMPRESS;
@@ -231,7 +238,19 @@
 
 					defaultSelectedPackets = defaultPackagesList;
 					out.flush();
-				} else {
+                                } else if (entry.getName().equals("packages.properties") ) {
+                                    int count;
+                                    byte data[] = new byte[BUFFER];
+                                    ByteArrayOutputStream out = new ByteArrayOutputStream();
+
+                                    while ((count = zipInputStream.read(data, 0, BUFFER)) != -1) {
+                                            out.write(data, 0, count);
+                                    }
+                                    InputStream in = new ByteArrayInputStream(out.toByteArray());
+                                    properties.load(in);
+                                    IOUtils.closeQuietly(in);
+                                    IOUtils.closeQuietly(out);
+                                } else {
 //					logger.debug("Extracting all Plugins, plugin: " + name);
 					if (option == OPTION_INSTALL) {
 
@@ -318,29 +337,19 @@
 		byte data[] = new byte[BUFFER];
 		int count = 0;
 
-		TaskStatusManager manager = ToolsLocator.getTaskStatusManager();
-		SimpleTaskStatus taskStatus = manager
-				.createDefaultSimpleTaskStatus("Uncompressing...");
-		
-		manager.add(taskStatus);
 		int countRootFolders = 0;
 		String entryName = "(header)";
 		try {
 			long readed = 0;
-	
-			// // First read all the contents size
-			// zis = new ZipInputStream(inputStream);
-			// while ((entry = zis.getNextEntry()) != null) {
-			// count += entry.getSize();
-			// }
-			// // zis.close();
-			// taskStatus.setRangeOfValues(0, count);
-	
-			// Return the stream to the initial position
+                        if( taskStatus!=null ) {
+                            taskStatus.push();
+                        }
 			zis = new ZipInputStream(inputStream);
 			while ((entry = zis.getNextEntry()) != null) {
 				entryName = FilenameUtils.separatorsToSystem(entry.getName());
-				taskStatus.message(entryName);
+                                if( taskStatus!=null ) {
+                                    taskStatus.message(entryName);
+                                }
 	
 				File file = new File(outputDirectory, entryName);
 				if (file.exists()) {
@@ -365,7 +374,9 @@
 					while ((count = zis.read(data, 0, BUFFER)) != -1) {
 						fos.write(data, 0, count);
 						readed += count;
-						taskStatus.setCurValue(readed);
+                                                if( taskStatus!=null ) {
+                                                    taskStatus.setCurValue(readed);
+                                                }
 					}
 					fos.flush();
 					fos.close();
@@ -379,14 +390,11 @@
 		} catch(RuntimeException ex) {
 			logger.warn("Problems uncompresing plugin (last entry '"+entryName+"'.",ex);
 			throw ex;
-			
-		} finally {
-		    
-		    taskStatus.remove();
-		    
-		}
-		
-        
+                } finally {
+                    if( taskStatus!=null ) {
+                        taskStatus.pop();
+                    }
+                }
 	}
 
 	private void createParentFolder(File file) {
@@ -435,7 +443,9 @@
 		InstallerInfoFileReader installerInfoFileReader = new InstallerInfoFileReader();
 		installerInfoFileReader.read(installerInfo, new ByteArrayInputStream(
 				out.toByteArray()));
-
+                if( taskStatus!=null ) {                
+                    taskStatus.message(installerInfo.getName());
+                }
 		return installerInfo;
 	}
 
@@ -447,4 +457,8 @@
 	public List<String> getDefaultSelectedPackages() {
 		return defaultSelectedPackets;
 	}
+        
+	public Properties getProperties() {
+		return properties;
+	}
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/DefaultInstallerProviderServices.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/DefaultInstallerProviderServices.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/DefaultInstallerProviderServices.java	(revision 43126)
@@ -33,6 +33,7 @@
 import java.io.OutputStream;
 import java.util.List;
 import java.util.Map;
+import java.util.Properties;
 
 import org.gvsig.installer.lib.api.PackageInfo;
 import org.gvsig.installer.lib.api.creation.MakePluginPackageServiceException;
@@ -45,6 +46,7 @@
 import org.gvsig.installer.lib.spi.InstallerInfoFileException;
 import org.gvsig.installer.lib.spi.InstallerProviderLocator;
 import org.gvsig.tools.service.spi.AbstractProviderServices;
+import org.gvsig.tools.task.SimpleTaskStatus;
 
 /**
  * @author <a href="mailto:jpiera@gvsig.org">Jorge Piera Llodr&aacute;</a>
@@ -52,7 +54,8 @@
 public class DefaultInstallerProviderServices extends AbstractProviderServices
 		implements InstallPackageProviderServices {
 
-	private List<String> defaultSelectedPacketsIDs = null;
+    private List<String> defaultSelectedPacketsIDs = null;
+    private Properties properties;
 
 	// private static final Logger LOG = LoggerFactory
 	// .getLogger(DefaultInstallerProviderServices.class);
@@ -156,28 +159,36 @@
 		return decompress.searchPlugin(is, zipEntry);
 	}
 
+    @Override
 	public void readPackageSetInfo(InputStream is,
 			List<PackageInfo> installerInfos,
-			Map<PackageInfo, String> zipEntriesMap)
+			Map<PackageInfo, String> zipEntriesMap, SimpleTaskStatus taskStatus)
 			throws InstallPackageServiceException {
-		Decompress decompress = new Decompress();
-		decompress
-				.readPackageSetInstallInfos(is, installerInfos, zipEntriesMap);
+		Decompress decompress = new Decompress(taskStatus);
+		decompress.readPackageSetInstallInfos(is, installerInfos, zipEntriesMap);
 
 		defaultSelectedPacketsIDs = decompress.getDefaultSelectedPackages();
+                properties = decompress.getProperties();
 	}
 
+    @Override
 	public void readPackageInfo(InputStream is,
 			List<PackageInfo> installerInfos,
-			Map<PackageInfo, String> zipEntriesMap, String name)
+			Map<PackageInfo, String> zipEntriesMap, String name, SimpleTaskStatus taskStatus)
 			throws InstallPackageServiceException {
 
-		Decompress decompress = new Decompress();
+		Decompress decompress = new Decompress(taskStatus);
 		decompress.readPackageInstallInfo(is, installerInfos, zipEntriesMap,
 				name);
 	}
 
-	public List<String> getDefaultSelectedPackagesIDs() {
-		return defaultSelectedPacketsIDs;
-	}
+    @Override
+    public List<String> getDefaultSelectedPackagesIDs() {
+            return defaultSelectedPacketsIDs;
+    }
+
+    @Override
+    public Properties getProperties() {
+            return properties;
+    }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/execution/DefaultInstallPackageService.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/execution/DefaultInstallPackageService.java	(revision 43125)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.lib/org.gvsig.installer.lib.impl/src/main/java/org/gvsig/installer/lib/impl/execution/DefaultInstallPackageService.java	(revision 43126)
@@ -3,29 +3,27 @@
  *
  * Copyright (C) 2007-2013 gvSIG Association.
  *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation; either version 3
- * of the License, or (at your option) any later version.
+ * This program is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU General Public License as published by the Free Software
+ * Foundation; either version 3 of the License, or (at your option) any later
+ * version.
  *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
+ * This program is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+ * details.
  *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
- * MA  02110-1301, USA.
+ * You should have received a copy of the GNU General Public License along with
+ * this program; if not, write to the Free Software Foundation, Inc., 51
+ * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
  *
- * For any additional information, do not hesitate to contact us
- * at info AT gvsig.com, or visit our website www.gvsig.com.
+ * For any additional information, do not hesitate to contact us at info AT
+ * gvsig.com, or visit our website www.gvsig.com.
  */
 /*
  * AUTHORS (In addition to CIT):
  * 2010 {Prodevelop}   {Task}
  */
-
 package org.gvsig.installer.lib.impl.execution;
 
 import java.io.BufferedInputStream;
@@ -43,7 +41,9 @@
 import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
+import java.util.Properties;
 import java.util.Set;
+import org.apache.commons.lang3.StringUtils;
 
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
